"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

require("core-js/modules/es6.array.index-of");

require("core-js/modules/es6.promise");

require("core-js/modules/es6.string.iterator");

require("core-js/modules/es6.array.from");

require("core-js/modules/es6.regexp.to-string");

require("core-js/modules/es6.date.to-string");

require("core-js/modules/es7.symbol.async-iterator");

require("core-js/modules/es6.array.is-array");

require("core-js/modules/es6.object.define-properties");

require("core-js/modules/es7.object.get-own-property-descriptors");

require("core-js/modules/es6.array.for-each");

require("core-js/modules/es6.array.filter");

require("core-js/modules/es6.symbol");

require("core-js/modules/es6.object.define-property");

require("core-js/modules/es6.array.reduce");

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

require("regenerator-runtime/runtime");

require("core-js/modules/web.dom.iterable");

require("core-js/modules/es6.array.iterator");

require("core-js/modules/es6.object.to-string");

require("core-js/modules/es6.object.keys");

require("core-js/modules/es6.regexp.constructor");

var _path = _interopRequireDefault(require("path"));

var _graphql = require("graphql");

var _expressGraphql = _interopRequireDefault(require("express-graphql"));

var _graphqlTools = require("graphql-tools");

var _execa = _interopRequireDefault(require("execa"));

var _findCacheDir = _interopRequireDefault(require("find-cache-dir"));

var _outputFileSync = _interopRequireDefault(require("output-file-sync"));

var _koaCompose = _interopRequireDefault(require("koa-compose"));

var _koaBodyparser = _interopRequireDefault(require("koa-bodyparser"));

var _debug = _interopRequireDefault(require("debug"));

var _d3DirTree = _interopRequireDefault(require("@mikojs/utils/lib/d3DirTree"));

var _requireModule2 = _interopRequireDefault(require("@mikojs/utils/lib/requireModule"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var debugLog = (0, _debug["default"])('graphql');
/** koa-graphql */

var Graphql =
/**
 * @example
 * new Graphql('folder path')
 *
 * @param {string} folderPath - folder path
 * @param {optionsType} options - make executable schema options
 */
function Graphql(folderPath) {
  var _this = this;

  var _ref = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {},
      additionalTypeDefs = _ref.typeDefs,
      additionalResolvers = _ref.resolvers,
      _ref$options = _ref.options,
      _options = _ref$options === void 0 ? {} : _ref$options;

  _classCallCheck(this, Graphql);

  this.schema = void 0;
  this.folderPath = void 0;
  this.options = void 0;

  this.update = function (filePath) {
    var _this$options;

    if (!new RegExp(_path["default"].resolve(_this.folderPath)).test(filePath)) return;
    var newResolvers = (0, _requireModule2["default"])(filePath);
    delete newResolvers.typeDefs;
    if (Object.keys(newResolvers).length === 0) return;
    (0, _graphqlTools.addResolveFunctionsToSchema)({
      schema: _this.schema,
      resolvers: newResolvers,
      resolverValidationOptions: _objectSpread({}, (_this$options = _this.options) === null || _this$options === void 0 ? void 0 : _this$options.requireResolversForResolveType, {
        requireResolversForResolveType: false
      }),
      inheritResolversFromInterfaces: true
    });
  };

  this.relay = function (argv) {
    var schemaFilePath = _path["default"].resolve((0, _findCacheDir["default"])({
      name: 'koa-graphql'
    }), './schema.graphql');

    debugLog(schemaFilePath);
    (0, _outputFileSync["default"])(schemaFilePath, (0, _graphql.printSchema)(_this.schema));
    return (0, _execa["default"])('relay-compiler', ['--schema', schemaFilePath].concat(_toConsumableArray(argv)), {
      stdio: 'inherit'
    });
  };

  this.middleware = function (options) {
    return (0, _koaCompose["default"])([(0, _koaBodyparser["default"])(),
    /*#__PURE__*/
    function () {
      var _ref2 = _asyncToGenerator(
      /*#__PURE__*/
      _regenerator["default"].mark(function _callee(ctx, next) {
        return _regenerator["default"].wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                ctx.res.statusCode = 200;
                _context.next = 3;
                return (0, _expressGraphql["default"])(_objectSpread({}, options, {
                  schema: _this.schema
                }))(ctx.request, ctx.res);

              case 3:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }));

      return function (_x, _x2) {
        return _ref2.apply(this, arguments);
      };
    }()]);
  };

  var _d3DirTree$leaves$red = (0, _d3DirTree["default"])(folderPath, {
    extensions: /.jsx?$/
  }).leaves().reduce(function (result, _ref3) {
    var filePath = _ref3.data.path;

    var _requireModule = (0, _requireModule2["default"])(filePath),
        newTypeDefs = _requireModule.typeDefs,
        newResolvers = _objectWithoutProperties(_requireModule, ["typeDefs"]);

    return {
      typeDefs: [].concat(_toConsumableArray(result.typeDefs), [newTypeDefs]),
      resolvers: Object.keys(newResolvers).reduce(function (prevResolvers, resolverName) {
        return _objectSpread({}, prevResolvers, _defineProperty({}, resolverName, _objectSpread({}, prevResolvers[resolverName], {}, newResolvers[resolverName])));
      }, result.resolvers)
    };
  }, {
    typeDefs: additionalTypeDefs instanceof Array || !additionalTypeDefs ? additionalTypeDefs || [] : [additionalTypeDefs],
    resolvers: additionalResolvers || {}
  }),
      typeDefs = _d3DirTree$leaves$red.typeDefs,
      resolvers = _d3DirTree$leaves$red.resolvers;

  debugLog({
    typeDefs: typeDefs,
    resolvers: resolvers
  });
  this.folderPath = folderPath;
  this.options = _options;
  this.schema = (0, _graphqlTools.makeExecutableSchema)(_objectSpread({}, _options, {
    resolverValidationOptions: _objectSpread({}, _options.requireResolversForResolveType, {
      requireResolversForResolveType: false
    }),
    typeDefs: typeDefs,
    resolvers: resolvers
  }));
}
/**
 * @example
 * graphql.update('/file-path')
 *
 * @param {string} filePath - file path
 */
;

exports["default"] = Graphql;
module.exports = exports.default;