"use strict";

require("core-js/modules/es6.object.define-property");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _default = {
  typeDefs: "\n  # An object with an ID.\n  interface Node {\n    # ID of the object.\n    id: ID!\n  }\n\n  # An edge in a connection.\n  interface Edge {\n    # A cursor for use in pagination.\n    cursor: String!\n\n    # The item at the end of the edge.\n    node: Node!\n  }\n\n  # Look up data listings.\n  interface Connection {\n    # A list of edges.\n    edges: [Edge]!\n\n    # Information to aid in pagination.\n    pageInfo: PageInfo!\n\n    # Identifies the total count of items in the connection.\n    total: Int!\n  }\n\n  # Information about pagination in a connection.\n  type PageInfo {\n    # When paginating forwards, the cursor to continue.\n    endCursor: String\n\n    # When paginating forwards, are there more items?\n    hasNextPage: Boolean!\n\n    # When paginating backwards, are there more items?\n    hasPreviousPage: Boolean!\n\n    # When paginating backwards, the cursor to continue.\n    startCursor: String\n  }\n"
};
exports["default"] = _default;
module.exports = exports.default;